Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1462464 (speedometer) - Review Request: speedometer - Chart network TX/RX and file download rates on the console
Summary: Review Request: speedometer - Chart network TX/RX and file download rates on ...
Keywords:
Status: CLOSED RAWHIDE
Alias: speedometer
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jaroslav Škarvada
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: hollywood
TreeView+ depends on / blocked
 
Reported: 2017-06-17 21:15 UTC by Raphael Groner
Modified: 2018-07-22 10:17 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-07-22 10:17:03 UTC
Type: ---
Embargoed:
jskarvad: fedora-review+


Attachments (Terms of Use)

Description Raphael Groner 2017-06-17 21:15:07 UTC
Spec URL: http://raphgro.fedorapeople.org//speedometer.spec
SRPM URL: http://raphgro.fedorapeople.org//speedometer-2.8-1.fc26.src.rpm

Description:
Measure and display the rate of data across a network connection
or data being stored in a file.

Comment 1 Raphael Groner 2017-06-17 21:38:17 UTC
Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=20057130

Comment 2 Jaroslav Škarvada 2017-08-21 08:00:18 UTC
Sorry for a bit delay, I am handing the review to Andrew J. Schorr, who I am mentoring at the moment.

Comment 3 Jaroslav Škarvada 2017-08-23 12:51:07 UTC
Well, I finally did the review myself, sorry for the delay and noise :)

I think that the spec (and dist-git repo/project) should be named python-speedometer. I.e. that's exactly the same what I am trying to achieve in the bug 1481645 with the pyobd package. The fedora naming guideline [1] is not explicit about it, but I think that the section for Python modules apply.

Also I think that the %files section should be empty and that the executable should be shipped in the python2- package. The Python packaging guidelines [2] aren't explicit about it, but it makes sense to me: e.g. later, when the upstream will add support for python 3 you will just add version suffix to the main executables and both will be shipped, each in corresponding package (this is in the guideline), also you will not need to ship CHANGELOG twice.

I would prefer making module from the main code, i.e. shipping the code in the sitelib and only the main loader in the /usr/bin (i.e. no *.py in the /usr/bin). That's exactly what I did in pyobd. Currently the python2-speedometer package is empty (contains only the EGG and changelog) and the python2 code is shipped in the speedometer package, which renders the concept of python2/python3 subpackages useless. Moreover, the rpmbuild cannot create precompiled *.pyc in the /usr/bin. I am afraid if the package will be run by root user stalled (owned by none package) .pyc will be created under /usr/bin, which seems really bad.



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.

Upstream should be convinced to add the license file.

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later)", "Unknown or generated". 1 files have
     unknown license. Detailed output of licensecheck in /home/yarda/git-
     fedora/speedometer/1462464-speedometer/licensecheck.txt
[-]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.

See comments in the beginning.

[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

At least python-urwid runtime dependency is missing, I got the following when trying to run the package:

Traceback (most recent call last):
  File "/usr/bin/speedometer", line 6, in <module>
    from pkg_resources import load_entry_point
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 2958, in <module>
    @_call_aside
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 2944, in _call_aside
    f(*args, **kwargs)
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 2971, in _initialize_master_working_set
    working_set = WorkingSet._build_master()
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 635, in _build_master
    ws.require(__requires__)
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 943, in require
    needed = self.resolve(parse_requirements(requirements))
  File "/usr/lib/python2.7/site-packages/pkg_resources/__init__.py", line 829, in resolve
    raise DistributionNotFound(req, requirers)
pkg_resources.DistributionNotFound: The 'urwid>=0.9.9.1' distribution was not found and is required by Speedometer

There may be more requires (I didn't check).

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[!]: Package complies to the Packaging Guidelines

See comments in the beginning.

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

Please convince upstream to add the license file.

[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-speedometer

Not needed

[!]: Package functions as described.

No, package tracebacks for me, because it has mising requirements (see above).

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: speedometer-2.8-1.fc27.noarch.rpm
          python2-speedometer-2.8-1.fc27.noarch.rpm
          speedometer-2.8-1.fc27.src.rpm
speedometer.noarch: W: no-manual-page-for-binary speedometer.py
speedometer.noarch: W: no-manual-page-for-binary speedometer
3 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
speedometer.noarch: W: no-manual-page-for-binary speedometer
speedometer.noarch: W: no-manual-page-for-binary speedometer.py
2 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
speedometer (rpmlib, GLIBC filtered):
    /usr/bin/python2
    python2-speedometer

python2-speedometer (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
speedometer:
    speedometer

python2-speedometer:
    python-speedometer
    python2-speedometer
    python2.7dist(speedometer)
    python2dist(speedometer)



Source checksums
----------------
http://excess.org/speedometer/speedometer-2.8.tar.gz :
  CHECKSUM(SHA256) this package     : d599fd36dfd886fe199a4d901ade02d803069de66ad7b6e40022f337f68c0b18
  CHECKSUM(SHA256) upstream package : d599fd36dfd886fe199a4d901ade02d803069de66ad7b6e40022f337f68c0b18


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1462464 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


[1] https://fedoraproject.org/wiki/Packaging:Naming?rd=Packaging:NamingGuidelines
[2] https://fedoraproject.org/wiki/Packaging:Python

Comment 4 Petr Viktorin (pviktori) 2017-08-24 12:41:00 UTC
This is an application that happens to be written in Python. The implementation language doesn't matter, since:
- other software isn't expected to import the Python module
- users aren't expected to write Python extensions

Given this, it doesn't make sense to package this as a Python module; see [Libraries and Applications] in Fedora guidelines. The naming guidelines for Python modules don't apply.

Since this is an application, please only package the Python2 version. Then, as soon as upstream adds support for py3, switch to it and drop py2.


[Libraries and Applications]: https://fedoraproject.org/wiki/Packaging:Guidelines#Libraries_and_Applications

Comment 5 Jaroslav Škarvada 2017-08-28 09:37:10 UTC
(In reply to Petr Viktorin from comment #4)
> This is an application that happens to be written in Python. The
> implementation language doesn't matter, since:
> - other software isn't expected to import the Python module
> - users aren't expected to write Python extensions
> 
> Given this, it doesn't make sense to package this as a Python module; see
> [Libraries and Applications] in Fedora guidelines. The naming guidelines for
> Python modules don't apply.
> 
> Since this is an application, please only package the Python2 version. Then,
> as soon as upstream adds support for py3, switch to it and drop py2.
> 
> 
> [Libraries and Applications]:
> https://fedoraproject.org/wiki/Packaging:
> Guidelines#Libraries_and_Applications

Petr thanks for info.

What about the *.pyc/*.pyo? Is it OK to ship the Python2 version of speedometer.py in /usr/bin without the precompiled byte code?

Comment 6 Petr Viktorin (pviktori) 2017-08-28 10:59:23 UTC
(In reply to Jaroslav Škarvada from comment #5)

> What about the *.pyc/*.pyo? Is it OK to ship the Python2 version of
> speedometer.py in /usr/bin without the precompiled byte code?

Yes. Python only automatically caches compiled bytecode for imported modules, not for ones that are run directly.
This does mean that start-up time will be slower than it would be if the code was in a library, but that doesn't seem to be a problem here.

Comment 7 Jaroslav Škarvada 2017-08-28 11:08:35 UTC
(In reply to Petr Viktorin from comment #6)
> (In reply to Jaroslav Škarvada from comment #5)
> 
> > What about the *.pyc/*.pyo? Is it OK to ship the Python2 version of
> > speedometer.py in /usr/bin without the precompiled byte code?
> 
> Yes. Python only automatically caches compiled bytecode for imported
> modules, not for ones that are run directly.
> This does mean that start-up time will be slower than it would be if the
> code was in a library, but that doesn't seem to be a problem here.

OK, thanks for info, so this is not issue here.

For the review the rest of the comments applies.

Comment 8 Raphael Groner 2017-09-19 19:50:28 UTC
(In reply to Jaroslav Škarvada from comment #7)
> (In reply to Petr Viktorin from comment #6)
> > (In reply to Jaroslav Škarvada from comment #5)
> > 
> > > What about the *.pyc/*.pyo? Is it OK to ship the Python2 version of
> > > speedometer.py in /usr/bin without the precompiled byte code?
> > 
> > Yes. Python only automatically caches compiled bytecode for imported
> > modules, not for ones that are run directly.
> > This does mean that start-up time will be slower than it would be if the
> > code was in a library, but that doesn't seem to be a problem here.
> 
> OK, thanks for info, so this is not issue here.
> 
> For the review the rest of the comments applies.

Yeah. I've never seen such a thing in any package of the known repositories.

Comment 9 Raphael Groner 2017-09-19 21:56:19 UTC
Spec URL: http://raphgro.fedorapeople.org//speedometer.spec
SRPM URL: http://raphgro.fedorapeople.org//speedometer-2.8-2.fc26.src.rpm

%changelog
* Tue Sep 19 2017 Raphael Groner <> - 2.8-2
- move binary into versionized subpackage
- add dependency python-urwid
- prepare build conditional for epel7
- prepare subpackage for python3, upstream is not ready yet

Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=2197567

Comment 10 Raphael Groner 2017-09-19 21:56:59 UTC
Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=21975674

Comment 11 Jaroslav Škarvada 2017-10-12 09:52:18 UTC
(In reply to Raphael Groner from comment #9)
> Spec URL: http://raphgro.fedorapeople.org//speedometer.spec
> SRPM URL: http://raphgro.fedorapeople.org//speedometer-2.8-2.fc26.src.rpm
> 
> %changelog
> * Tue Sep 19 2017 Raphael Groner <> - 2.8-2
> - move binary into versionized subpackage
> - add dependency python-urwid
> - prepare build conditional for epel7
> - prepare subpackage for python3, upstream is not ready yet
> 
> Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=2197567

Sorry for the delay. I didn't receive notification from bugzilla and I was on holidays :)

Could you please re-upload the srpm and spec? I am getting 404 error.

Comment 13 Jaroslav Škarvada 2017-10-17 18:00:37 UTC
Approved.

Comment 15 Gwyn Ciesla 2017-10-23 12:19:34 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/speedometer

Comment 16 Fedora Update System 2017-10-23 16:23:11 UTC
speedometer-2.8-2.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-6750a53e97

Comment 17 Raphael Groner 2018-07-22 06:11:17 UTC
Lost due to negative karma.

Comment 18 Raphael Groner 2018-07-22 10:17:03 UTC
Builds available in F28 and rawhide.


Note You need to log in before you can comment on or make changes to this bug.